<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CancelTransactionResult StructType
 * Meta information extracted from the WSDL
 * - type: tns:CancelTransactionResult
 * @subpackage Structs
 */
class CancelTransactionResult extends GenericResult
{
    /**
     * The transactionState
     * @var int
     */
    public $transactionState;
    /**
     * Constructor method for CancelTransactionResult
     * @uses CancelTransactionResult::setTransactionState()
     * @param int $transactionState
     */
    public function __construct($transactionState = null)
    {
        $this
            ->setTransactionState($transactionState);
    }
    /**
     * Get transactionState value
     * @return int|null
     */
    public function getTransactionState()
    {
        return $this->transactionState;
    }
    /**
     * Set transactionState value
     * @param int $transactionState
     * @return \StructType\CancelTransactionResult
     */
    public function setTransactionState($transactionState = null)
    {
        // validation for constraint: int
        if (!is_null($transactionState) && !(is_int($transactionState) || ctype_digit($transactionState))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($transactionState, true), gettype($transactionState)), __LINE__);
        }
        $this->transactionState = $transactionState;
        return $this;
    }
}
