<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GenericArguments StructType
 * @subpackage Structs
 */
class GenericArguments extends AbstractStructBase
{
    /**
     * The password
     * @var string
     */
    public $password;
    /**
     * The username
     * @var string
     */
    public $username;
    /**
     * Constructor method for GenericArguments
     * @uses GenericArguments::setPassword()
     * @uses GenericArguments::setUsername()
     * @param string $password
     * @param string $username
     */
    public function __construct($password = null, $username = null)
    {
        $this
            ->setPassword($password)
            ->setUsername($username);
    }
    /**
     * Get password value
     * @return string|null
     */
    public function getPassword()
    {
        return $this->password;
    }
    /**
     * Set password value
     * @param string $password
     * @return \StructType\GenericArguments
     */
    public function setPassword($password = null)
    {
        // validation for constraint: string
        if (!is_null($password) && !is_string($password)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($password, true), gettype($password)), __LINE__);
        }
        $this->password = $password;
        return $this;
    }
    /**
     * Get username value
     * @return string|null
     */
    public function getUsername()
    {
        return $this->username;
    }
    /**
     * Set username value
     * @param string $username
     * @return \StructType\GenericArguments
     */
    public function setUsername($username = null)
    {
        // validation for constraint: string
        if (!is_null($username) && !is_string($username)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($username, true), gettype($username)), __LINE__);
        }
        $this->username = $username;
        return $this;
    }
}
